diff --git a/src/libponyc/codegen/codegen.h b/src/libponyc/codegen/codegen.h
index 901d69bb29..92d2b44b21 100644
--- a/src/libponyc/codegen/codegen.h
+++ b/src/libponyc/codegen/codegen.h
@@ -39,7 +39,6 @@ LLVMValueRef LLVMMemcpy(LLVMModuleRef module, bool ilp32);
 LLVMValueRef LLVMMemmove(LLVMModuleRef module, bool ilp32);
 LLVMValueRef LLVMLifetimeStart(LLVMModuleRef module);
 LLVMValueRef LLVMLifetimeEnd(LLVMModuleRef module);
-LLVMValueRef LLVMInvariantStart(LLVMModuleRef module);
 
 #define GEN_NOVALUE ((LLVMValueRef)1)
 
diff --git a/src/libponyc/codegen/gencall.c b/src/libponyc/codegen/gencall.c
index 83fe05a25a..6b279b9e94 100644
--- a/src/libponyc/codegen/gencall.c
+++ b/src/libponyc/codegen/gencall.c
@@ -902,23 +902,3 @@ void gencall_lifetime_end(compile_t* c, LLVMValueRef ptr)
   args[1] = LLVMBuildBitCast(c->builder, ptr, c->void_ptr, "");
   LLVMBuildCall(c->builder, func, args, 2, "");
 }
-
-void gencall_invariant_start(compile_t* c, LLVMValueRef ptr)
-{
-  LLVMValueRef func = LLVMInvariantStart(c->module);
-  LLVMTypeRef type = LLVMGetElementType(LLVMTypeOf(ptr));
-  size_t size = (size_t)LLVMABISizeOfType(c->target_data, type);
-
-  LLVMValueRef args[2];
-  // Check if we were passed a Pony Pointer. If so, the object is variable
-  // sized.
-  if(LLVMTypeOf(ptr) == c->void_ptr)
-  {
-    args[0] = LLVMConstInt(c->i64, -1, true);
-    args[1] = ptr;
-  } else {
-    args[0] = LLVMConstInt(c->i64, size, false);
-    args[1] = LLVMBuildBitCast(c->builder, ptr, c->void_ptr, "");
-  }
-  LLVMBuildCall(c->builder, func, args, 2, "");
-}
diff --git a/src/libponyc/codegen/gencall.h b/src/libponyc/codegen/gencall.h
index 4f1fb84a46..71865a0773 100644
--- a/src/libponyc/codegen/gencall.h
+++ b/src/libponyc/codegen/gencall.h
@@ -36,8 +36,6 @@ void gencall_lifetime_start(compile_t* c, LLVMValueRef ptr);
 
 void gencall_lifetime_end(compile_t* c, LLVMValueRef ptr);
 
-void gencall_invariant_start(compile_t* c, LLVMValueRef ptr);
-
 PONY_EXTERN_C_END
 
 #endif
diff --git a/src/libponyc/codegen/genprim.c b/src/libponyc/codegen/genprim.c
index ef21de1563..03a39ef1b9 100644
--- a/src/libponyc/codegen/genprim.c
+++ b/src/libponyc/codegen/genprim.c
@@ -196,14 +196,6 @@ static void pointer_apply(compile_t* c, void* data, token_id cap)
       LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
   }
 
-  ast_t* typearg = ast_child(ast_childidx(t->ast, 2));
-  if(cap == TK_VAL || ((ast_id(typearg) == TK_NOMINAL) &&
-    (cap_single(typearg) == TK_VAL)))
-  {
-    if(LLVMGetTypeKind(LLVMTypeOf(result)) == LLVMPointerTypeKind)
-      gencall_invariant_start(c, result);
-  }
-
   LLVMBuildRet(c->builder, result);
   codegen_finishfun(c);
 }
@@ -226,13 +218,6 @@ static void pointer_update(compile_t* c, reach_type_t* t, reach_type_t* t_elem)
   LLVMValueRef loc = LLVMBuildInBoundsGEP(c->builder, elem_ptr, &index, 1, "");
   LLVMValueRef result = LLVMBuildLoad(c->builder, loc, "");
 
-  ast_t* typearg = ast_child(ast_childidx(t->ast, 2));
-  if((ast_id(typearg) == TK_NOMINAL) && (cap_single(typearg) == TK_VAL))
-  {
-    if(LLVMGetTypeKind(LLVMTypeOf(result)) == LLVMPointerTypeKind)
-      gencall_invariant_start(c, result);
-  }
-
   LLVMBuildStore(c->builder, LLVMGetParam(m->func, 2), loc);
 
   LLVMBuildRet(c->builder, result);
@@ -331,13 +316,6 @@ static void pointer_delete(compile_t* c, reach_type_t* t, reach_type_t* t_elem)
     LLVMPointerType(t_elem->use_type, 0), "");
   LLVMValueRef result = LLVMBuildLoad(c->builder, elem_ptr, "");
 
-  ast_t* typearg = ast_child(ast_childidx(t->ast, 2));
-  if((ast_id(typearg) == TK_NOMINAL) && (cap_single(typearg) == TK_VAL))
-  {
-    if(LLVMGetTypeKind(LLVMTypeOf(result)) == LLVMPointerTypeKind)
-      gencall_invariant_start(c, result);
-  }
-
   LLVMValueRef src = LLVMBuildInBoundsGEP(c->builder, elem_ptr, &n, 1, "");
   src = LLVMBuildBitCast(c->builder, src, t->use_type, "");
   LLVMValueRef elen = LLVMBuildMul(c->builder, len, l_size, "");
@@ -537,11 +515,6 @@ static void maybe_apply(compile_t* c, void* data, token_id cap)
   LLVMPositionBuilderAtEnd(c->builder, is_false);
   result = LLVMBuildBitCast(c->builder, result, t_elem->use_type, "");
 
-  ast_t* typearg = ast_child(ast_childidx(t->ast, 2));
-  if(cap == TK_VAL || ((ast_id(typearg) == TK_NOMINAL) &&
-    (cap_single(typearg) == TK_VAL)))
-    gencall_invariant_start(c, result);
-
   LLVMBuildRet(c->builder, result);
 
   LLVMPositionBuilderAtEnd(c->builder, is_true);
diff --git a/src/libponyc/codegen/genreference.c b/src/libponyc/codegen/genreference.c
index 8d4298b752..24dadc14a9 100644
--- a/src/libponyc/codegen/genreference.c
+++ b/src/libponyc/codegen/genreference.c
@@ -104,14 +104,6 @@ LLVMValueRef gen_fieldload(compile_t* c, ast_t* ast)
     LLVMSetMetadata(field, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
   }
 
-  ast_t* f_type = ast_type(ast);
-
-  if((ast_id(f_type) == TK_NOMINAL) && (cap_single(f_type) == TK_VAL))
-  {
-    if(LLVMGetTypeKind(LLVMTypeOf(field)) == LLVMPointerTypeKind)
-      gencall_invariant_start(c, field);
-  }
-
   return field;
 }
 
@@ -122,14 +114,6 @@ LLVMValueRef gen_fieldembed(compile_t* c, ast_t* ast)
   if(field == NULL)
     return NULL;
 
-  ast_t* f_type = ast_type(ast);
-
-  if((ast_id(f_type) == TK_NOMINAL) && (cap_single(f_type) == TK_VAL))
-  {
-    if(LLVMGetTypeKind(LLVMTypeOf(field)) == LLVMPointerTypeKind)
-      gencall_invariant_start(c, field);
-  }
-
   return field;
 }
 
@@ -245,14 +229,6 @@ LLVMValueRef gen_localload(compile_t* c, ast_t* ast)
     LLVMSetMetadata(local, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
   }
 
-  ast_t* l_type = ast_type(ast);
-
-  if((ast_id(l_type) == TK_NOMINAL) && (cap_single(l_type) == TK_VAL))
-  {
-    if(LLVMGetTypeKind(LLVMTypeOf(local)) == LLVMPointerTypeKind)
-      gencall_invariant_start(c, local);
-  }
-
   return local;
 }
 
diff --git a/src/libponyc/codegen/host.cc b/src/libponyc/codegen/host.cc
index aa907d7db6..8aa90579f7 100644
--- a/src/libponyc/codegen/host.cc
+++ b/src/libponyc/codegen/host.cc
@@ -180,10 +180,3 @@ LLVMValueRef LLVMLifetimeEnd(LLVMModuleRef module)
 
   return wrap(Intrinsic::getDeclaration(m, Intrinsic::lifetime_end, {}));
 }
-
-LLVMValueRef LLVMInvariantStart(LLVMModuleRef module)
-{
-  Module* m = unwrap(module);
-
-  return wrap(Intrinsic::getDeclaration(m, Intrinsic::invariant_start, {}));
-}
